from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Directory, File, String, Int, Float, Boolean

Virsorter_Run_V0_1_0 = CommandToolBuilder(tool="virsorter_run", base_command=["virsorter", "run"], inputs=[ToolInput(tag="in_working_dir", input_type=Directory(optional=True), prefix="--working-dir", doc=InputDocumentation(doc="output directory")), ToolInput(tag="in_db_dir", input_type=File(optional=True), prefix="--db-dir", doc=InputDocumentation(doc="database directory, default to the --db-dir\nset during installation")), ToolInput(tag="in_seq_file", input_type=File(optional=True), prefix="--seqfile", doc=InputDocumentation(doc="sequence file in fa or fq format (could be\ncompressed by gzip or bz2)  [required]")), ToolInput(tag="in_include_groups", input_type=String(optional=True), prefix="--include-groups", doc=InputDocumentation(doc="classifiers of viral groups to included (comma\nseparated and no space in between)  [default:\ndsDNAphage,NCLDV,RNA,ssDNA,lavidaviridae]")), ToolInput(tag="in_jobs", input_type=Int(optional=True), prefix="--jobs", doc=InputDocumentation(doc="max # of jobs allowed in parallel.  [default:\n8]")), ToolInput(tag="in_min_score", input_type=Float(optional=True), prefix="--min-score", doc=InputDocumentation(doc="minimal score to be identified as viral\n[default: 0.5]")), ToolInput(tag="in_hallmark_required_on_short", input_type=Boolean(optional=True), prefix="--hallmark-required-on-short", doc=InputDocumentation(doc="require hallmark gene short seqs (length\ncutoff as 'short' were set in template-\nconfig.yaml file); this can reduce false\npositives at reasonable cost of sensitivity\n[default: False]")), ToolInput(tag="in_provirus_off", input_type=Boolean(optional=True), prefix="--provirus-off", doc=InputDocumentation(doc="To turn off extracting provirus after\nclassifying full contig seqs; Togetehr with\nlower --max-orf-per-seq, can speed up a run\nsignificantly  [default: False]")), ToolInput(tag="in_max_orf_per_seq", input_type=Int(optional=True), prefix="--max-orf-per-seq", doc=InputDocumentation(doc="Max # of orf used for computing taxonomic\nfeatures; if # of orf in a seq exceeds the max\nlimit, it is sub-sampled to this # to reduce\ncomputation; to turn off this, set it to -1;\nthis option must be used together with\n--provirus-off option  [default: 20]")), ToolInput(tag="in_min_length", input_type=Int(optional=True), prefix="--min-length", doc=InputDocumentation(doc="minimal seq length required; all seqs shorter\nthan this will be removed  [default: 0]")), ToolInput(tag="in_tmpdir", input_type=Directory(optional=True), prefix="--tmpdir", doc=InputDocumentation(doc="Directory name for intermediate files")), ToolInput(tag="in_verbose", input_type=Boolean(optional=True), prefix="--verbose", doc=InputDocumentation(doc="shows detailed rules output  [default: False]")), ToolInput(tag="in_profile", input_type=String(optional=True), prefix="--profile", doc=InputDocumentation(doc="snakemake profile e.g. for cluster execution.")), ToolInput(tag="in_dry_run", input_type=Boolean(optional=True), prefix="--dryrun", doc=InputDocumentation(doc="Check rules to run and files to produce\n[default: False]")), ToolInput(tag="in_use_cond_a_off", input_type=Boolean(optional=True), prefix="--use-conda-off", doc=InputDocumentation(doc="Stop using the conda envs (vs2.yaml) that come\nwith this package and use what are installed\nin current system; Only useful when you want\nto install dependencies on your own with your\nown prefer versions  [default: False]")), ToolInput(tag="in_rm_tmpdir", input_type=Boolean(optional=True), prefix="--rm-tmpdir", doc=InputDocumentation(doc="Remove intermediate file directory (--tmpdir)\n[default: False]")), ToolInput(tag="in_all_vertical_line_classify", input_type=String(optional=True), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_snake_make_args", input_type=String(optional=True), position=1, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_working_dir", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_working_dir", type_hint=File()), doc=OutputDocumentation(doc="output directory"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Virsorter_Run_V0_1_0().translate("wdl", allow_empty_container=True)

